CREATE TABLE `academic` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rgm` int(11) DEFAULT NULL,
  `name` varchar(50) DEFAULT NULL,
  `email` varchar(45) DEFAULT NULL,
  `date_insert` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `academic_matters` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cod_academic` int(11) DEFAULT NULL,
  `cod_matters` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_academic_matters_academic_idx` (`cod_academic`),
  KEY `fk_academic_matters_idx` (`cod_matters`),
  CONSTRAINT `fk_academic_matters` FOREIGN KEY (`cod_matters`) REFERENCES `matters` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `fk_academic_matters_academic` FOREIGN KEY (`cod_academic`) REFERENCES `academic` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `avisos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(45) DEFAULT NULL,
  `text` text,
  `coverage` char(1) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `backup` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` datetime DEFAULT NULL,
  `title` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `matters` (
  `id` int(11) NOT NULL,
  `name` varchar(45) DEFAULT NULL,
  `time` int(11) DEFAULT NULL,
  `qtd` int(11) DEFAULT NULL,
  `period` char(1) DEFAULT NULL,
  `date_insert` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `release_notes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `notes` double DEFAULT NULL,
  `cod_matters` int(11) DEFAULT NULL,
  `cod_academic` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_release_notes_academic_idx` (`cod_academic`),
  KEY `fk_release_notes_matters_idx` (`cod_matters`),
  CONSTRAINT `fk_release_notes_academic` FOREIGN KEY (`cod_academic`) REFERENCES `academic` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `fk_release_notes_matters` FOREIGN KEY (`cod_matters`) REFERENCES `matters` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
