package solucoesemtecnologia.com.br.tcc;

import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.NavigationView;
import android.support.v4.view.GravityCompat;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;

import solucoesemtecnologia.com.br.tcc.activity.Avisos;
import solucoesemtecnologia.com.br.tcc.activity.Faults;
import solucoesemtecnologia.com.br.tcc.activity.Grades;
import solucoesemtecnologia.com.br.tcc.activity.Informative;
import solucoesemtecnologia.com.br.tcc.activity.Matters;
import solucoesemtecnologia.com.br.tcc.activity.TaskUniversity;

public class MainActivity extends AppCompatActivity implements NavigationView.OnNavigationItemSelectedListener {
    private Toolbar toolbar;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        if(getSupportActionBar() != null){
            getSupportActionBar().setTitle("SIGA");
        }

        init_main();
    }

    public void init_main(){
        /*FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                        .setAction("Action", null).show();
            }
        });*/

        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        ActionBarDrawerToggle toggle = new ActionBarDrawerToggle(
                this, drawer, toolbar, R.string.navigation_drawer_open, R.string.navigation_drawer_close);
        drawer.setDrawerListener(toggle);
        toggle.syncState();

        NavigationView navigationView = (NavigationView) findViewById(R.id.nav_view);
        navigationView.setNavigationItemSelectedListener(this);
    }

    @Override
    public void onBackPressed() {
        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        if (drawer.isDrawerOpen(GravityCompat.START)) {
            drawer.closeDrawer(GravityCompat.START);
        } else {
            super.onBackPressed();
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @SuppressWarnings("StatementWithEmptyBody")
    @Override
    public boolean onNavigationItemSelected(MenuItem item) {
        // Handle navigation view item clicks here.
        int id = item.getItemId();

        switch (id){
            case R.id.nav_notas:
                Log.e("SYNC-APP", "CONECTOU NOTAS");
                startActivity(new Intent(this, Grades.class));
                break;
            case R.id.nav_faltas:
                Log.e("SYNC-APP", "CONECTOU FALTAS");
                startActivity(new Intent(this, Faults.class));
                break;
            case R.id.nav_materia:
                Log.e("SYNC-APP", "CONECTOU MATERIAS");
                startActivity(new Intent(this, Matters.class));
                break;
            case R.id.nav_avisos:
                Log.e("SYNC-APP", "CONECTOU AVISO");
                startActivity(new Intent(this, Avisos.class));
                break;
            case R.id.nav_trabalho:
                Log.e("SYNC-APP", "CONECTOU TRABALHOS");
                startActivity(new Intent(this, TaskUniversity.class));
                break;
            case R.id.nav_informativo:
                Log.e("SYNC-APP", "CONECTOU INFORMATIVO");
                startActivity(new Intent(this, Informative.class));
                break;
            case R.id.nav_conta:
                break;
            case R.id.nav_ajuda:
                break;
        }

        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        drawer.closeDrawer(GravityCompat.START);
        return true;
    }
}
