package solucoesemtecnologia.com.br.tcc.activity;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.media.Ringtone;
import android.media.RingtoneManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.NotificationCompat;
import android.support.v4.widget.SwipeRefreshLayout;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.widget.ExpandableListView;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import solucoesemtecnologia.com.br.tcc.R;
import solucoesemtecnologia.com.br.tcc.adapters.AdapterExpandableNotes;
import solucoesemtecnologia.com.br.tcc.dao.NotesDAO;
import solucoesemtecnologia.com.br.tcc.data.Notes;

/**
 * Created by julio on 03/08/16.
 */
public class Avisos extends AppCompatActivity {
    private List<Notes> listNotesAdapter = new ArrayList<>();
    private Toolbar toolbar;
    private SwipeRefreshLayout refreshLayout;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.layout_avisos);

        refreshLayout = (SwipeRefreshLayout) findViewById(R.id.refreshNotice);

        toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        if(getSupportActionBar() != null){
            getSupportActionBar().setTitle("Avisos");
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        }

        if(isConnected()){
            SelectNoticesServer noticesServer = new SelectNoticesServer(this);
            noticesServer.execute();
        }

        refreshLayout.setOnRefreshListener(new SwipeRefreshLayout.OnRefreshListener() {
            @Override
            public void onRefresh() {
                if(isConnected()){
                    SelectNoticesServer noticesServer = new SelectNoticesServer(Avisos.this);
                    noticesServer.execute();
                }
            }
        });
    }

    private class SelectNoticesServer extends AsyncTask<Object, String, String>{
        private NotesDAO notesDAO;

        public SelectNoticesServer(Context context){
            notesDAO = new NotesDAO(context);
        }

        @Override
        protected String doInBackground(Object... params) {
            String answer = "";

            if(isConnected()){
                HttpClient httpClient = new DefaultHttpClient();
                HttpPost httpPost = new HttpPost("http://52.203.137.99/mobile/notice.php");

                JSONArray arrayNotes = CodeMessage();

                ArrayList<NameValuePair> valores = new ArrayList<>();
                valores.add(new BasicNameValuePair("type", "1"));
                valores.add(new BasicNameValuePair("idMessage", String.valueOf(arrayNotes)));

                try{
                    httpPost.setEntity(new UrlEncodedFormEntity(valores));

                    HttpResponse resposta = httpClient.execute(httpPost);
                    answer = EntityUtils.toString(resposta.getEntity());
                }
                catch(NullPointerException e){ e.printStackTrace(); }
                catch(ClientProtocolException e){ e.printStackTrace(); }
                catch(IOException e){ e.printStackTrace(); }
            }

            return answer;
        }

        @Override
        protected void onPostExecute(String notice) {
            try {
                JSONObject jsonObject = new JSONObject(notice);

                Log.e("SYNC-APP", "NOTICE SERVER 1 : " + jsonObject);

                if(Integer.valueOf(jsonObject.getString("success")) == 1){
                    JSONArray arrayNotice = new JSONArray(jsonObject.getString("data"));

                    Log.e("SYNC-APP", "NOTICE SERVER: " + arrayNotice);

                    for (int i = 0; i < arrayNotice.length(); i++){
                        JSONObject objNotice = arrayNotice.getJSONObject(i);
                        Notes notes = new Notes(
                                objNotice.getString("title"),
                                objNotice.getString("text"),
                                objNotice.getString("date_current"),
                                1,
                                Integer.valueOf(objNotice.getString("id")
                                ));

                        Notification(objNotice.getString("title"), objNotice.getString("text"));

                        notesDAO.SalveNotes(notes);
                    }

                    refreshLayout.setRefreshing(false);
                    UpdateListNotes();
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }

        }

        private void Notification(String title, String message){
            NotificationManager manager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
            PendingIntent pi = PendingIntent.getActivity(Avisos.this, 0, new Intent(Avisos.this, Avisos.class), 0);

            NotificationCompat.Builder builder = new NotificationCompat.Builder(Avisos.this);
            builder.setTicker("Nome Aviso");
            builder.setContentTitle(UpCaseWord(title));
            builder.setContentText(message);
            builder.setSmallIcon(android.R.drawable.stat_notify_more);
            builder.setContentIntent(pi);
            builder.setAutoCancel(true);

            try{
                Uri som = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
                Ringtone toque = RingtoneManager.getRingtone(Avisos.this, som);
                toque.play();
            }catch (Exception e){

            }

            Notification n = builder.build();
            n.vibrate = new long[]{200, 300, 200, 300};
            manager.notify(100, n);
        }

        private JSONArray CodeMessage(){
            List<Notes> notesList = notesDAO.SelectNotes();
            JSONArray arrayNotes = new JSONArray();
            JSONObject objNotes;

            Log.e("SYNC-APP", "SIZE LIST: " + notesList.size());

            for (Notes notes : notesList){
                objNotes = new JSONObject();

                try {
                    Log.e("SYNC-APP", "ID: " + notes.getCOD_SERVER());
                    objNotes.put("idMessage", notes.getCOD_SERVER());

                    arrayNotes.put(objNotes);
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }

            return arrayNotes;
        }

        public String UpCaseWord(String string){
            String[] words = string.toLowerCase().split(" ");
            String response = "";

            for(String word : words){
                char upCase = Character.toUpperCase(word.charAt(0));

                response += (new StringBuilder(word.substring(1)).insert(0, upCase)) + " ";
            }

            return response;
        }
    }

    public void UpdateListNotes(){
        final NotesDAO notesDAO = new NotesDAO(this);

        listNotesAdapter.clear();
        listNotesAdapter = notesDAO.SelectNotes();

        final ExpandableListView expandableListView = (ExpandableListView) findViewById(R.id.exp_notes);
        expandableListView.setAdapter(new AdapterExpandableNotes(this, listNotesAdapter));

        expandableListView.setOnGroupExpandListener(new ExpandableListView.OnGroupExpandListener() {
            @Override
            public void onGroupExpand(int groupPosition) {
                notesDAO.UpdateStatusNotes(groupPosition);
            }
        });
    }

    /*Verifica se existe conexao de Internet*/
    private boolean isConnected(){
        ConnectivityManager conn = (ConnectivityManager) getBaseContext().getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo networkInfo = conn.getActiveNetworkInfo();

        return networkInfo != null && networkInfo.isConnected();
    }
}
