package solucoesemtecnologia.com.br.tcc.activity;

import android.graphics.Color;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.widget.ArrayAdapter;
import android.widget.ProgressBar;
import android.widget.Spinner;
import android.widget.TextView;

import com.prolificinteractive.materialcalendarview.CalendarDay;
import com.prolificinteractive.materialcalendarview.MaterialCalendarView;
import com.prolificinteractive.materialcalendarview.OnDateSelectedListener;
import com.prolificinteractive.materialcalendarview.OnMonthChangedListener;
import com.prolificinteractive.materialcalendarview.format.ArrayWeekDayFormatter;
import com.prolificinteractive.materialcalendarview.format.MonthArrayTitleFormatter;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;
import java.util.Random;
import java.util.concurrent.Executors;

import solucoesemtecnologia.com.br.tcc.R;
import solucoesemtecnologia.com.br.tcc.decorators.EventDecorator;

/**
 * Created by julio on 04/08/16.
 */
public class Faults extends AppCompatActivity implements OnDateSelectedListener, OnMonthChangedListener {
    private Toolbar toolbar;
    private static final DateFormat FORMATTER = SimpleDateFormat.getDateInstance();
    private MaterialCalendarView widget;
    private TextView textView;
    private ProgressBar progressBar;

    /*
    * INSERIR EFEITO PARA CARREGAR O CALENDÁRIO IGUAL DO EMAIL - LISTA DE EMPRESA DO TA ABERTO
    * */


    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.layout_faults);

        toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        if(getSupportActionBar() != null){
            getSupportActionBar().setTitle("Faltas");
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        }

        final Spinner spinner = (Spinner) findViewById(R.id.selectMatters);
        String[] plants = new String[]{
                "Engenharia de Software",
                "Análise de Algoritmo",
                "Programação Paralela e Distribuida",
                "Analise de Projeto Final de Curso"
        };

        final List<String> plantsList = new ArrayList<>(Arrays.asList(plants));
        final ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(
                this, R.layout.spinner_item, plantsList);

        spinnerArrayAdapter.setDropDownViewResource(R.layout.spinner_item);
        spinner.setAdapter(spinnerArrayAdapter);
        spinner.setSelection(1);

        widget = (MaterialCalendarView) findViewById(R.id.calendarView);
        textView = (TextView) findViewById(R.id.textView);

        widget.setOnDateChangedListener(this);
        widget.setOnMonthChangedListener(this);

        Calendar instance = Calendar.getInstance();
        widget.setSelectedDate(instance.getTime());

        widget.setTitleFormatter(new MonthArrayTitleFormatter(getResources().getTextArray(R.array.custom_months)));
        widget.setWeekDayFormatter(new ArrayWeekDayFormatter(getResources().getTextArray(R.array.custom_weekdays)));
        widget.setHeaderTextAppearance(R.style.TextAppearance_AppCompat_Medium);
        widget.setWeekDayTextAppearance(R.style.TextAppearance_AppCompat_Medium);
        widget.setSelectionColor(R.color.colorGreyPrimarySecond);
        widget.setArrowColor(R.color.colorPrimary);

        new ApiSimulator().executeOnExecutor(Executors.newSingleThreadExecutor());
    }

    @Override
    public void onDateSelected(@NonNull MaterialCalendarView widget, @NonNull CalendarDay date, boolean selected) {
        //textView.setText(getSelectedDatesString());
    }

    @Override
    public void onMonthChanged(MaterialCalendarView widget, CalendarDay date) {
        //getSupportActionBar().setTitle(FORMATTER.format(date.getDate()));
    }

    private String getSelectedDatesString() {
        CalendarDay date = widget.getSelectedDate();
        if (date == null) {
            return "No Selection";
        }
        return FORMATTER.format(date.getDate());
    }

    private class ApiSimulator extends AsyncTask<Void, Void, ArrayList<ArrayList<CalendarDay>>> {

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }


        @Override
        protected ArrayList<ArrayList<CalendarDay>> doInBackground(@NonNull Void... voids) {



            Calendar calendar = Calendar.getInstance();

            ArrayList<CalendarDay> datesRed = new ArrayList<>();
            ArrayList<CalendarDay> datesBlue = new ArrayList<>();
            ArrayList<ArrayList<CalendarDay>> dates2 = new ArrayList<>();

            for(int i = 1; i <= 20; i++){
                Random random = new Random();
                int n = random.nextInt(10);
                if(n % 2 == 0){
                    calendar.set(Calendar.MONTH, Calendar.SEPTEMBER);
                    calendar.set(Calendar.DAY_OF_MONTH, i);

                    CalendarDay day = CalendarDay.from(calendar);

                    datesRed.add(day);
                }else{
                    calendar.set(Calendar.MONTH, Calendar.SEPTEMBER);
                    calendar.set(Calendar.DAY_OF_MONTH, i);

                    CalendarDay day = CalendarDay.from(calendar);

                    datesBlue.add(day);
                }
            }

            dates2.add(datesRed);
            dates2.add(datesBlue);

            return dates2;
        }

        @Override
        protected void onPostExecute(@NonNull ArrayList<ArrayList<CalendarDay>> calendarDays) {
            super.onPostExecute(calendarDays);

            if (isFinishing()) {
                return;
            }

            widget.addDecorator(new EventDecorator(Color.RED, calendarDays.get(0)));
            widget.addDecorator(new EventDecorator(Color.BLUE, calendarDays.get(1)));
        }
    }
}
