package solucoesemtecnologia.com.br.tcc.activity;

import android.annotation.TargetApi;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.widget.ImageView;
import android.widget.TextView;

import com.akexorcist.roundcornerprogressbar.RoundCornerProgressBar;

import solucoesemtecnologia.com.br.tcc.R;

/**
 * Created by julio on 05/08/16.
 */
public class Informative extends AppCompatActivity {
    private Toolbar toolbar;
    private Handler handler = new Handler();
    private ImageView img_status_course;
    private TextView tv_status_course;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.layout_informative);

        toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        if(getSupportActionBar() != null){
            getSupportActionBar().setTitle("Informativo");
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        }

        final RoundCornerProgressBar progressBar = (RoundCornerProgressBar) findViewById(R.id.progress_bar);
        img_status_course = (ImageView) findViewById(R.id.img_status_course);
        tv_status_course = (TextView) findViewById(R.id.tv_status_course);

        progressBar.setProgressColor(R.color.green_one);
        progressBar.setProgressBackgroundColor(R.color.grey);
        progressBar.setMax(100);

        new Thread(new Runnable() {
            int i = 0;
            int progressStatus = 0;

            @TargetApi(Build.VERSION_CODES.M)
            @Override
            public void run() {
                while(progressStatus < 100){
                    progressStatus += doWork();

                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }

                    // Update the progress bar
                    handler.post(new Runnable() {
                        public void run() {
                            tv_status_course.setText((i+1) + "0%");
                            if(i >= 2.5){
                                img_status_course.setImageResource(R.mipmap.ic_sentiment_neutral_black_36dp);
                            }

                            if(i >= 5){
                                img_status_course.setImageResource(R.mipmap.ic_sentiment_satisfied_black_36dp);
                            }

                            if(i >= 7.5){
                                img_status_course.setImageResource(R.mipmap.ic_sentiment_very_satisfied_black_36dp);
                            }
                            Log.e("SYNC-APP", "VALOR I: " + i);
                            progressBar.setProgress(progressStatus);
                            i++;
                        }
                    });
                }
            }

            private int doWork() {
                return i * 3;
            }
        }).start();
    }
}
