package solucoesemtecnologia.com.br.tcc.activity;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.widget.ListView;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import solucoesemtecnologia.com.br.tcc.R;
import solucoesemtecnologia.com.br.tcc.adapters.AdapterMatters;
import solucoesemtecnologia.com.br.tcc.dao.AcademicDAO;
import solucoesemtecnologia.com.br.tcc.dao.MattersDAO;
import solucoesemtecnologia.com.br.tcc.data.Academic;
import solucoesemtecnologia.com.br.tcc.data.Matter;

/**
 * Created by julio on 05/08/16.
 */
public class Matters extends AppCompatActivity {
    Toolbar toolbar;
    private MattersDAO mattersDAO;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.layout_matters);

        toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        if(getSupportActionBar() != null){
            getSupportActionBar().setTitle("Matérias Matriculado");
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        }

        mattersDAO = new MattersDAO(this);

        if(isConnected()){
            SelectMattersServer mattersServer = new SelectMattersServer();
            mattersServer.execute();
        }

        /*final CheckedTextView checkedTextView = (CheckedTextView) findViewById(R.id.checkedTextView1);

        checkedTextView.setCheckMarkDrawable(R.mipmap.ic_done_black_18dp);
        checkedTextView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (checkedTextView.isChecked())
                    checkedTextView.setChecked(false);
                else
                    checkedTextView.setChecked(true);
            }
        });*/
    }

    private class SelectMattersServer extends AsyncTask<Object, String, String>{
        private AcademicDAO academicDAO;
        private Academic academic;
        @Override
        protected String doInBackground(Object... params) {
            String answer = "";

            if(isConnected()){
                academicDAO = new AcademicDAO(getBaseContext());

                academic = academicDAO.selectAcademic();

                HttpClient httpClient = new DefaultHttpClient();
                HttpPost httpPost = new HttpPost("http://52.203.137.99/mobile/matters.php");

                ArrayList<NameValuePair> valores = new ArrayList<>();
                valores.add(new BasicNameValuePair("type", "1"));
                valores.add(new BasicNameValuePair("cod_academic", String.valueOf(academic.getCODE_SERVER())));

                try{
                    httpPost.setEntity(new UrlEncodedFormEntity(valores));

                    HttpResponse resposta = httpClient.execute(httpPost);
                    answer = EntityUtils.toString(resposta.getEntity());
                }
                catch(NullPointerException e){ e.printStackTrace(); }
                catch(ClientProtocolException e){ e.printStackTrace(); }
                catch(IOException e){ e.printStackTrace(); }
            }

            return answer;
        }

        @Override
        protected void onPostExecute(String matters) {
            try {
                JSONObject jsonObject = new JSONObject(matters);

                if(Integer.valueOf(jsonObject.getString("success")) == 1){
                    JSONArray arrayMatters = new JSONArray(jsonObject.getString("data"));
                    List<Matter> matterList = new ArrayList<>();

                    for (int i = 0; i < arrayMatters.length(); i++){
                        JSONObject objMatter = arrayMatters.getJSONObject(i);
                        matterList.add(new Matter(
                                objMatter.getString("title"),
                                objMatter.getString("teacher"),
                                true,
                                Integer.valueOf(objMatter.getString("id"))
                        ));
                    }

                    Log.e("SYNC-APP", "TESTE: " + matterList.get(0).getNAME_MATTER());

                    ListView listView = (ListView) findViewById(R.id.lv_matters);
                    listView.setAdapter(new AdapterMatters(matterList, getBaseContext()));
                }else{
                    Log.e("SYNC-APP", "ERROR: " + jsonObject);
                }

            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
    }

    /*Verifica se existe conexao de Internet*/
    private boolean isConnected(){
        ConnectivityManager conn = (ConnectivityManager) getBaseContext().getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo networkInfo = conn.getActiveNetworkInfo();

        return networkInfo != null && networkInfo.isConnected();
    }
}
