package solucoesemtecnologia.com.br.tcc.activity;

import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.EditText;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;

import solucoesemtecnologia.com.br.tcc.MainActivity;
import solucoesemtecnologia.com.br.tcc.R;
import solucoesemtecnologia.com.br.tcc.dao.AcademicDAO;
import solucoesemtecnologia.com.br.tcc.data.Academic;

/**
 * Created by julio on 26/10/16.
 */
public class Register extends AppCompatActivity {
    private EditText rgm;
    private EditText pass;
    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.layout_register);
    }

    public void register(View view) {
        rgm = (EditText) findViewById(R.id.edt_rgm);
        pass = (EditText) findViewById(R.id.edt_pass);

        Log.e("SYNC-APP", "RGM: " + Integer.valueOf(rgm.getText().toString()));
        Log.e("SYNC-APP", "PASS: " + pass.getText().toString());

        CheckRegister register = new CheckRegister(Integer.valueOf(rgm.getText().toString()), pass.getText().toString());
        register.execute();
    }

    private class CheckRegister extends AsyncTask<Object, String, String> {
        private int rgm;
        private String pass;

        public CheckRegister(int rgm, String pass){
            this.rgm = rgm;
            this.pass = pass;
        }

        @Override
        protected String doInBackground(Object[] params) {
            String answer = "";

            if(isConnected()){
                HttpClient httpClient = new DefaultHttpClient();
                HttpPost httpPost = new HttpPost("http://52.203.137.99/mobile/access.php");

                ArrayList<NameValuePair> valores = new ArrayList<>();
                valores.add(new BasicNameValuePair("type", "1"));
                valores.add(new BasicNameValuePair("rgm", String.valueOf(rgm)));
                valores.add(new BasicNameValuePair("password", String.valueOf(pass)));

                try{
                    httpPost.setEntity(new UrlEncodedFormEntity(valores));

                    HttpResponse resposta = httpClient.execute(httpPost);
                    answer = EntityUtils.toString(resposta.getEntity());
                }
                catch(NullPointerException e){ e.printStackTrace(); }
                catch(ClientProtocolException e){ e.printStackTrace(); }
                catch(IOException e){ e.printStackTrace(); }
            }

            return answer;
        }

        @Override
        protected void onPostExecute(String response) {
            try {
                JSONObject jsonObject = new JSONObject(response);
                if(Integer.valueOf(jsonObject.getString("success")) == 1){
                    JSONObject valueAcademic = new JSONObject(jsonObject.getString("data"));

                    AcademicDAO academicDAO = new AcademicDAO(Register.this);

                    Log.e("SYNC-APP", "VALUE: " + valueAcademic);
                    Log.e("SYNC-APP", "VALUE ID: " + valueAcademic.getString("id"));

                    academicDAO.salveAcademic(new Academic(
                            Integer.valueOf(valueAcademic.getString("id")),
                            Integer.valueOf(valueAcademic.getString("rgm")),
                            String.valueOf(valueAcademic.getString("course")),
                            String.valueOf(valueAcademic.getString("password")),
                            String.valueOf(valueAcademic.getString("name")),
                            String.valueOf(valueAcademic.getString("email")),
                            String.valueOf(valueAcademic.getString("cell_number")),
                            String.valueOf(valueAcademic.getString("telephone_number"))
                    ));

                    startActivity(new Intent(Register.this, MainActivity.class));
                }else{
                    Log.e("SYNC-APP", "ERRO: " + Integer.valueOf(jsonObject.getString("success")));
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
    }

    /*Verifica se existe conexao de Internet*/
    private boolean isConnected(){
        ConnectivityManager conn = (ConnectivityManager) getBaseContext().getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo networkInfo = conn.getActiveNetworkInfo();

        return networkInfo != null && networkInfo.isConnected();
    }
}
