package solucoesemtecnologia.com.br.tcc.adapters;

import android.content.Context;
import android.graphics.Typeface;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.List;

import solucoesemtecnologia.com.br.tcc.R;
import solucoesemtecnologia.com.br.tcc.data.Notes;
import solucoesemtecnologia.com.br.tcc.data.General;

/**
 * Created by julio on 03/08/16.
 */
public class AdapterExpandableNotes extends BaseExpandableListAdapter {
    private List<Notes> listNotes;
    private LayoutInflater inflater;
    private General severalUpCase = new General();

    public AdapterExpandableNotes(Context context, List<Notes> listNotes) {
        this.listNotes = listNotes;
        inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    @Override
    public int getGroupCount() {
        return listNotes.size();
    }

    @Override
    public int getChildrenCount(int groupPosition) {
        return 1;
    }

    @Override
    public Object getGroup(int groupPosition) {
        return listNotes.get(groupPosition);
    }

    @Override
    public Object getChild(int groupPosition, int childPosition) {
        return listNotes.get(groupPosition);
    }

    @Override
    public long getGroupId(int groupPosition) {
        return listNotes.get(groupPosition).getCOD_SERVER();
    }

    @Override
    public long getChildId(int groupPosition, int childPosition) {
        return listNotes.get(groupPosition).getCOD_SERVER();
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup parent) {
        HolderMessage holderMessage;


        if(convertView == null){
            convertView = inflater.inflate(R.layout.exp_notes_group, null);

            holderMessage = new HolderMessage();
            convertView.setTag(holderMessage);

            holderMessage.tv_title = (TextView) convertView.findViewById(R.id.tv_notes_title);
            holderMessage.iv_status = (ImageView) convertView.findViewById(R.id.iv_notes_status);
        }else{
            holderMessage = (HolderMessage) convertView.getTag();
        }

        if(listNotes.get(groupPosition).getSTATUS() == 1){
            holderMessage.tv_title.setTypeface(Typeface.DEFAULT_BOLD);
        }

        holderMessage.tv_title.setText(severalUpCase.UpCaseWord(listNotes.get(groupPosition).getTITLE()));

        return convertView;
    }

    @Override
    public View getChildView(int groupPosition, int childPosition, boolean isLastChild, View convertView, ViewGroup parent) {
        HolderMessage holderMessage;
        Notes notesChild = listNotes.get(groupPosition);

        if(convertView == null){
            convertView = inflater.inflate(R.layout.exp_notes_child, null);
            holderMessage = new HolderMessage();

            convertView.setTag(holderMessage);

            holderMessage.tv_message = (TextView) convertView.findViewById(R.id.tv_notes_message);
            holderMessage.tv_date = (TextView) convertView.findViewById(R.id.tv_notes_date_publication);
        }else{
            holderMessage = (HolderMessage) convertView.getTag();
        }

        Log.e("SYNC-APP", "Message: " + notesChild.getMESSAGE());

        holderMessage.tv_message.setText(notesChild.getMESSAGE());

        return convertView;
    }

    @Override
    public boolean isChildSelectable(int groupPosition, int childPosition) {
        return true;
    }

    class HolderMessage{
        TextView tv_message;
        TextView tv_title;
        TextView tv_date;
        ImageView iv_status;
    }
}
