package solucoesemtecnologia.com.br.tcc.adapters;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckedTextView;

import java.util.List;

import solucoesemtecnologia.com.br.tcc.R;
import solucoesemtecnologia.com.br.tcc.data.Matter;

/**
 * Created by julio on 27/10/16.
 */
public class AdapterMatters extends BaseAdapter {
    private List<Matter> matterList;
    private Context context;

    public AdapterMatters(List<Matter> matterList, Context context){
        this.matterList = matterList;
        this.context = context;

        Log.e("SYNC-APP", "ENTROU AQUI");
    }

    @Override
    public int getCount() {
        return matterList.size();
    }

    @Override
    public Object getItem(int position) {
        return matterList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return matterList.get(position).getCOD_SERVER();
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        Matter matter = matterList.get(position);
        View layout;

        if(convertView == null){
            LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);

            layout = inflater.inflate(R.layout.adapter_matters, null);
        }else{
            layout = convertView;
        }

        CheckedTextView txtMatter = (CheckedTextView) layout.findViewById(R.id.ctv_matter);

        txtMatter.setText(UpCaseWord(matter.getNAME_MATTER()));

        Log.e("SYNC-APP", "NAME MATTER: " + UpCaseWord(matter.getNAME_MATTER()));

        return layout;
    }

    private String UpCaseWord(String string){
        String[] words = string.toLowerCase().split(" ");
        String response = "";

        for(String word : words){
            char upCase = Character.toUpperCase(word.charAt(0));

            response += (new StringBuilder(word.substring(1)).insert(0, upCase)) + " ";
        }

        return response;
    }
}
