package solucoesemtecnologia.com.br.tcc.dao;

import android.annotation.TargetApi;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Build;
import android.util.Log;

import solucoesemtecnologia.com.br.tcc.data.Academic;
import solucoesemtecnologia.com.br.tcc.data.ColumnsTables;
import solucoesemtecnologia.com.br.tcc.utils.ConnectDataBase;

/**
 * Created by julio on 26/10/16.
 */
public class AcademicDAO {
    private ConnectDataBase helper;
    private SQLiteDatabase sqLiteDatabase;

    public AcademicDAO(Context context){
        this.helper = new ConnectDataBase(context);
    }

    private SQLiteDatabase getDatabase(){
        if(sqLiteDatabase == null){
            sqLiteDatabase = helper.getWritableDatabase();
        }

        return sqLiteDatabase;
    }
    @TargetApi(Build.VERSION_CODES.KITKAT)
    public Academic selectAcademic(){
        String[] columns = {
            ColumnsTables.ColumnsAcademics.NAME,
            ColumnsTables.ColumnsAcademics.COURSE,
            ColumnsTables.ColumnsAcademics.RGM,
            ColumnsTables.ColumnsAcademics.PASS,
            ColumnsTables.ColumnsAcademics.EMAIL,
            ColumnsTables.ColumnsAcademics.CELL_NUMBER,
            ColumnsTables.ColumnsAcademics.TELEPHONE_NUMBER,
            ColumnsTables.ColumnsAcademics.CODE_SERVER
        };

        Academic academic = null;

        try (Cursor c = getDatabase().query(ColumnsTables.ColumnsAcademics.TABLE_NAME, columns, null, null, null, null, null)){
            if(c.moveToFirst()){
                academic = AcademicDAO.fromCursor(c);
            }else{
                Log.e("SYNC-APP", "N TEM REGISTRO");
            }
        }

        return academic;
    }

    public void salveAcademic(Academic academic){
        ContentValues values = new ContentValues();

        values.put(ColumnsTables.ColumnsAcademics.NAME, academic.getNAME());
        values.put(ColumnsTables.ColumnsAcademics.COURSE, academic.getCOURSE());
        values.put(ColumnsTables.ColumnsAcademics.RGM, academic.getRGM());
        values.put(ColumnsTables.ColumnsAcademics.PASS, academic.getPASS());
        values.put(ColumnsTables.ColumnsAcademics.EMAIL, academic.getEMAIL());
        values.put(ColumnsTables.ColumnsAcademics.CELL_NUMBER, academic.getCELL_NUMBER());
        values.put(ColumnsTables.ColumnsAcademics.TELEPHONE_NUMBER, academic.getTELEPHONE_NUMBER());
        values.put(ColumnsTables.ColumnsAcademics.CODE_SERVER, academic.getCODE_SERVER());

        long id = getDatabase().insert(ColumnsTables.ColumnsAcademics.TABLE_NAME, null, values);
    }

    public int SelectRegister(){
        Cursor c = getDatabase().query(ColumnsTables.ColumnsAcademics.TABLE_NAME, null, null, null, null, null, null);

        int result = c.getCount();

        c.close();

        return result;
    }

    private static Academic fromCursor(Cursor c){
        return new Academic(
                c.getInt(c.getColumnIndex(ColumnsTables.ColumnsAcademics.CODE_SERVER)),
                c.getInt(c.getColumnIndex(ColumnsTables.ColumnsAcademics.RGM)),
                c.getString(c.getColumnIndex(ColumnsTables.ColumnsAcademics.COURSE)),
                c.getString(c.getColumnIndex(ColumnsTables.ColumnsAcademics.PASS)),
                c.getString(c.getColumnIndex(ColumnsTables.ColumnsAcademics.NAME)),
                c.getString(c.getColumnIndex(ColumnsTables.ColumnsAcademics.EMAIL)),
                c.getString(c.getColumnIndex(ColumnsTables.ColumnsAcademics.CELL_NUMBER)),
                c.getString(c.getColumnIndex(ColumnsTables.ColumnsAcademics.TELEPHONE_NUMBER))
        );
    }
}
