package solucoesemtecnologia.com.br.tcc.dao;

import android.annotation.TargetApi;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Build;

import java.util.ArrayList;
import java.util.List;

import solucoesemtecnologia.com.br.tcc.data.ColumnsTables;
import solucoesemtecnologia.com.br.tcc.data.Matter;
import solucoesemtecnologia.com.br.tcc.utils.ConnectDataBase;

/**
 * Created by julio on 26/10/16.
 */
public class MattersDAO {
    private ConnectDataBase helper;
    private SQLiteDatabase sqLiteDatabase;

    public MattersDAO(Context context){
        this.helper = new ConnectDataBase(context);
    }

    private SQLiteDatabase getDatabase(){
        if(sqLiteDatabase == null){
            sqLiteDatabase = helper.getWritableDatabase();
        }

        return sqLiteDatabase;
    }

    @TargetApi(Build.VERSION_CODES.KITKAT)
    public List<Matter> selectMatters(){
        List<Matter> listMatters = new ArrayList<>();
        String[] columns = {
                ColumnsTables.ColumnsMatters.COD_SERVER
        };


        try (Cursor c = getDatabase().query(ColumnsTables.ColumnsMatters.TABLE_NAME, columns, null, null, null, null, ColumnsTables.ColumnsMatters.COD_SERVER)){
            if(c.moveToFirst()){
                do {
                    Matter matter = MattersDAO.fromCursorMatter(c);
                    listMatters.add(matter);
                }while (c.moveToNext());
            }
        }

        return listMatters;
    }

    private static Matter fromCursorMatter(Cursor c){
        int cod_metter = c.getInt(c.getColumnIndex(ColumnsTables.ColumnsMatters.COD_SERVER));

        return new Matter(cod_metter);
    }
}
