package solucoesemtecnologia.com.br.tcc.dao;

import android.annotation.TargetApi;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Build;
import android.util.Log;

import java.util.ArrayList;
import java.util.List;

import solucoesemtecnologia.com.br.tcc.data.ColumnsTables;
import solucoesemtecnologia.com.br.tcc.data.Notes;
import solucoesemtecnologia.com.br.tcc.utils.ConnectDataBase;

/**
 * Created by julio on 03/08/16.
 */
public class NotesDAO {
    private ConnectDataBase helper;
    private SQLiteDatabase database;

    public NotesDAO(Context context){
        helper = new ConnectDataBase(context);
    }

    private SQLiteDatabase getDatabase(){
        if(database == null){
            database = helper.getWritableDatabase();
        }

        return database;
    }

    public void SalveNotes(Notes notes){
        ContentValues values = new ContentValues();

        values.put(ColumnsTables.ColumnsNotes.TITLE, notes.getTITLE());
        values.put(ColumnsTables.ColumnsNotes.MESSAGE, notes.getMESSAGE());
        values.put(ColumnsTables.ColumnsNotes.DATE_PULICATION, notes.getDATE_PUBLICATION());
        values.put(ColumnsTables.ColumnsNotes.STATUS, notes.getSTATUS());
        values.put(ColumnsTables.ColumnsNotes.COD_MESSAGE, notes.getCOD_SERVER());

        long _id = getDatabase().insert(ColumnsTables.ColumnsNotes.TABLE_NAME, null, values);

        Log.e("SYNC-APP", "ID NOTES: " + _id + " | COD_MESSAGE: " + notes.getCOD_SERVER());
    }

    @TargetApi(Build.VERSION_CODES.KITKAT)
    public List<Notes> SelectNotes(){
        String[] columns = {
                ColumnsTables.ColumnsNotes._ID,
                ColumnsTables.ColumnsNotes.TITLE,
                ColumnsTables.ColumnsNotes.MESSAGE,
                ColumnsTables.ColumnsNotes.DATE_PULICATION,
                ColumnsTables.ColumnsNotes.STATUS,
                ColumnsTables.ColumnsNotes.COD_MESSAGE
        };

        List<Notes> notes = new ArrayList<>();

        try (Cursor c = getDatabase().query(ColumnsTables.ColumnsNotes.TABLE_NAME, columns, null, null, null, null, ColumnsTables.ColumnsNotes.STATUS)){
            if(c.moveToFirst()){
                do {
                    Notes odd = NotesDAO.notesCursor(c);
                    notes.add(odd);
                }while (c.moveToNext());
            }
            return notes;
        }

    }

    public void UpdateStatusNotes(int idNotes){
        ContentValues values = new ContentValues();

        values.put(ColumnsTables.ColumnsNotes.STATUS, "0");

        getDatabase().update(ColumnsTables.ColumnsNotes.TABLE_NAME, values, ColumnsTables.ColumnsNotes._ID + " = ?", new String[]{String.valueOf(idNotes)});
    }

    private static Notes notesCursor(Cursor c){
        String title = c.getString(c.getColumnIndex(ColumnsTables.ColumnsNotes.TITLE));
        String message = c.getString(c.getColumnIndex(ColumnsTables.ColumnsNotes.MESSAGE));
        String date_puclication = c.getString(c.getColumnIndex(ColumnsTables.ColumnsNotes.DATE_PULICATION));
        int status = c.getInt(c.getColumnIndex(ColumnsTables.ColumnsNotes.STATUS));
        int cod_message = c.getInt(c.getColumnIndex(ColumnsTables.ColumnsNotes.COD_MESSAGE));

        return new Notes(title, message, date_puclication, status, cod_message);
    }
}
