<?php
	require_once '../connection/DataBase.class.php';
	
	class NotesDAO extends DataBase{
		/*Seleciona as notas de cada acadêmico, através do ID passado da tabela 'academics_matters'*/
		public function selectAcademicNotes($idAcademic){
			/*Selecionando dados de conexao com o BD*/
			$this->conn = new DataBase();
				
			$this->pdo = $this->conn->DatabaseDefault();
			
			$this->sql = "SELECT notes FROM academic_notes WHERE cod_academic_matters = ?";
			
			$this->query = $this->pdo->prepare($this->sql);
			
			$this->query->bindValue(1, $idAcademic);
			
			if($this->query->execute()){
				$rows = $this->query->fetchAll ( PDO::FETCH_OBJ );
					
				return array('success' => 1, 'data' => $rows);
			}else{
				$this->queryError = $this->query->errorInfo();
					
				parent::__destruct();
					
				return array("success" => 0, "alert" => "Error - ".$this->queryError[2]);
			}
		}
		
		/*Selecionar todos os acadêmicos de uma determinada matéria*/
		public function selectAcademicsMatter($idMatter){
			/*Selecionando dados de conexao com o BD*/
			$this->conn = new DataBase();
		
			$this->pdo = $this->conn->DatabaseDefault();
				
			$this->sql = "SELECT a.rgm, a.name, am.cod_academic, m.amount_avaluation
					FROM academics_matters AS am, academic AS a, matters AS m
					WHERE am.cod_academic = a.id
					AND am.cod_matter = m.id
					AND am.cod_matter = ?";
				
			$this->query = $this->pdo->prepare($this->sql);
				
			$this->query->bindValue(1, $idMatter);
				
			if($this->query->execute()){
				$rows = $this->query->fetchAll ( PDO::FETCH_OBJ );
					
				return array('success' => 1, 'data' => $rows);
			}else{
				$this->queryError = $this->query->errorInfo();
					
				parent::__destruct();
					
				return array("success" => 0, "alert" => "Error - ".$this->queryError[2]);
			}
		}
	}
?>