var dataMatters = [];

$(document).ready(function(){
	$.ajax({
		type: "post",
		dataType: "json",
		url: "class/controller/matters.php",
		data: {type : 2},
		success: function(data){
			if(data.success){
				var dataItem = [];
				
				$.each(data.data, function(index, value){
					var dataAux = [];
					var date = new Date(value.date_current);
					
					dataAux['id'] 	= value.id;
					dataAux['title']= value.title;
					dataAux['workload'] = value.workload;
					dataAux['amount_avaluation'] = value.amount_avaluation;
					dataAux['period'] = value.period;
					dataAux['action'] = '<button class="btn btn-danger" onclick="onDelete('+index+')"><i class="fa fa-trash"></i> Excluir</button>';
					
					dataItem.push(dataAux);
				});
				
				$('#table-matters').DataTable( {
					processing: true,
			        data: dataItem,
			        columns: [
			            { "data": "id" },
			            { "data": "title" },
			            { "data": "workload" },
			            { "data": "amount_avaluation" },
			            { "data": "period" },
			            { "data": "action" }
			        ]
			    });
				
				dataMatters = data.data;
			}else{
				alert("Erro: " + JSON.stringify(data, null, 4));
			}
		},
		error: function(){
			alert("Erro: " + JSON.stringify(data, null, 4));
		}
	});
			
});


$("#form-matter").submit(function(event){	
	$(".modal-body").empty();
	$(".modal-footer").empty();
		
	if($("#periodo").val() !== 's'){
		$.ajax({
			type: "post",
			dataType: "json",
			url: "class/controller/matters.php",
			data: {
				title : capitalizeFirstLetter($("#nome_mat").val()), 
				workload : $("#carga_horaria").val(), 
				amount_avaluation : $("#qtd_avaliacao").val(), 
				period : $("#periodo").val(),
				type : 1},
			success: function(data){
				if(data.success){
					var modal = $("#modal-information");
					
					modal.find('.modal-title').text("Nova Matéria");
					modal.find('.modal-body').append("<p>A matéria "+capitalizeFirstLetter($("#nome_mat").val())+", foi salva com sucesso.</p>");
					
					modal.find('.modal-footer').append("<button class='btn btn-default btn-close' data-dismiss='modal'><i class='fa fa-close'></i> Fechar</button>");
					
					modal.modal("show");
					
					$(".btn-close").click(function(){
						location.reload();
					});
				}else{
					alert("Erro: " + JSON.stringify(data, null, 4));
				}
			},
			error: function(data){
				alert("Erro: " + JSON.stringify(data, null, 4));
			}
		});
	}else{
		var modal = $("#modal-information");
		
		modal.find('.modal-title').text("Cadastrar Matéria");
		modal.find('.modal-body').append("<p>Você não selecionou um PERÍODO.</p>");
		
		modal.find('.modal-footer').append("<button class='btn btn-default btn-close' data-dismiss='modal'><i class='fa fa-close'></i> Fechar</button>");
		
		modal.modal("show");
		
		$("#periodo").focus();
	}
	
	event.preventDefault();
});

function capitalizeFirstLetter(string) {
	var sub_string = string.split(" ");
	var string_aux = "";
	
	for(i = 0; i < sub_string.length; i++){
		string_aux += sub_string[i].charAt(0).toUpperCase() + sub_string[i].slice(1) + " ";
	}
	
    return string_aux;
}

function onDelete(index){
	$(".modal-body").empty();
	$(".modal-footer").empty();

	$.ajax({
		type: "post",
		dataType: "json",
		url: "class/controller/matters.php",
		data: {type: 3, id: dataMatters[index].id},
		success: function(data){
			if(data.success){
				var modal = $("#modal-information");
				
				modal.find('.modal-title').text("Matéria");
				modal.find('.modal-body').append("<p>Matéria excluída com sucesso.</p>");
				
				modal.find('.modal-footer').append("<button class='btn btn-default btn-close' data-dismiss='modal'><i class='fa fa-close'></i> Fechar</button>");
				
				modal.modal("show");
				
				$(".btn-close").click(function(){
					location.reload();
				});
			}else{
				alert("Erro: " + JSON.stringify(data, null, 4));
			}
		},
		error: function(data){
			alert("Erro: " + JSON.stringify(data, null, 4));
		}
	});
}
function onEdit(index){
	//$(".modal-body").empty();
	//$(".modal-footer").empty();
	
	var modal = $("#modal-information");
	
	/*modal.find('.modal-title').text("Matéria");
	modal.find('.modal-body').append('<div class="row"><div class="form-group">'
										+'<label for="nome_mat" class="col-sm-2 col-md-2 col-lg-2 control-label">Nome</label>'
										+'<div class="col-sm-10 col-md-10 col-lg-10">'
											+'<input type="text" class="form-control form-cascade-control" id="nome_mat" name="nome_mat">'
										+'</div>'
									+'</div>'
									+'<div class="form-group">'
										+'<label for="carga_horaria" class="col-sm-2 col-md-2 col-lg-2 control-label">Carga Horária</label>'
										+'<div class="col-sm-3 col-md-2 col-lg-2">'
											+'<input type="text" class="form-control form-cascade-control" id="carga_horaria" name="carga_horaria">'
										+'</div>'
										+'<label for="qtd_avaliacao" class="col-sm-2 col-md-2 col-lg-2 control-label">Qtd. de Avaliação</label>'
										+'<div class="col-sm-3 col-md-2 col-lg-2">'
											+'<input type="text" class="form-control form-cascade-control" id="qtd_avaliacao" name="qtd_avaliacao" placeholder="4">'
										+'</div>'
										+'<label for="periodo" class="col-sm-2 col-md-1 col-lg-2 control-label">Período</label>'
										+'<div class="col-sm-3 col-md-3 col-lg-2">'
											+'<select class="form-control form-cascade-control" id="periodo">'
												+'<option value="s">--- Selecionar ---</option>'
												+'<option value="Vespertino">Vespertino</option>'
												+'<option value="Matutino">Matutino</option>'
												+'<option value="Noturno">Noturno</option>'
												+'<option value="Integral">Integral</option>'
											+'</select>'
										+'</div>'
									+'</div></div>');
	
	modal.find('.modal-footer').append("<button class='btn btn-default btn-close' data-dismiss='modal'><i class='fa fa-close'></i> Fechar</button>");*/
	
	modal.modal("show");
}