/*Variavel GLOBAL, onde ficara todos os academicos selecionados para materia*/
var arrayAcademic = [];

$(function() {	
	/*Seleciona as matérias*/
	$.ajax({
		type : "post",
		dataType : "json",
		url : "class/controller/matters.php",		
		data : {type : 2},
		success: function(data){
			if(data.success){
				var select = $("#select-matter");
				
				$.each(data.data, function(index, value){
					select.append('<option value="'+value.id+'">'+value.title+'</option>');
				});
			}else{
				alert("Erro: " + JSON.stringify(data, null, 4));
			}
		},
		error: function(data){
			alert("Erro: " + JSON.stringify(data, null, 4));
		}
	});
	
	var status = true;
	
	$("#select_academic").autocomplete({
		minLength : 2,
		source : function(request, response) {
			$.ajax({
				url : "class/controller/academic.php",
				dataType : "json",
				type : "post",
				data : {
					type : 2,
					value : $('#select_academic').val()
				},
				success : function(data) {					
					if(data.success){
						response($.map(data.data, function(item) {
							console.log(item);
							return {
								label : item.rgm,
								value : item.rgm,
								rgm : item.rgm,
								email : item.email,
								nome : item.name,
								id: item.id
							}
						}));
						
						/*Verifica se o aluno já foi escolhido*/
						(status) ? $(".alert-academic > .message-alert").hide() : status = false;
					}else{
						alert("Erro: " + JSON.stringify(data, null, 4));
					}
				},
				error : function(data) {
					alert("Erro: " + JSON.stringify(data, null, 4));
				}
			});
		},
		focus : function(event, ui) {
			//console.log(ui.item.rgm);
			// $("#esporte").val( ui.item.titulo );
		},
		select : function(event, ui) {
			var validate = false;
			
			/*verifica se academico esta na lista*/
			$.each(arrayAcademic, function(key, object){
				if(object.rgm == ui.item.rgm){
					validate = true;
				}
			});
			
			/*Se academico jah esta selecionado, messagem de erro senao adiciona na lista*/
			if(validate){
				MessageAlert();
			}else{
				arrayAcademic.push({id : ui.item.id, rgm : ui.item.rgm, nome: ui.item.nome});
				ViewAddAcademic(arrayAcademic);
			}
		}
	});	
	
	/*Mostra mensagem de academico jah inserido*/
	function MessageAlert(){
		$(".alert-academic > .message-alert").show();
		status = true;
	}
});
/*Deleta o academico no qual foi selecionado/clicado, e atualiza os dados na tela*/
function DeleteAcademic(rgm){	
	arrayAcademic = $.grep(arrayAcademic, function(e){
		return e.rgm != rgm;
	});
	
	ViewAddAcademic(arrayAcademic);
}

/*Insere academico na lista e mostra na tela*/
function ViewAddAcademic(arrayAcademic){
	var content = "";
	
	$.each(arrayAcademic, function(key, value){
		var name = capitalizeFirstLetter(value.nome.toLowerCase()).split(" ");
		
		content += '<div class="col-sm-3 col-md-3 col-lg-3">'
			+'<div class="input-group">'
				+'<span class="input-group-btn">'
					+'<a class="btn btn-danger" type="button" onClick="DeleteAcademic('+value.rgm+')">'
						+'<i class="fa fa-trash-o"></i>'
					+'</a>'
				+'</span>' 
				+'<input type="text" class="form-control" value="'+value.rgm+' - '+name[0]+'" disabled>'
			+'</div>'
		+'</div>';
	});
	
	$(".view-reg").html(content);
}

function capitalizeFirstLetter(string) {
	var sub_string = string.split(" ");
	var string_aux = "";
	
	for(i = 0; i < sub_string.length; i++){
		string_aux += sub_string[i].charAt(0).toUpperCase() + sub_string[i].slice(1) + " ";
	}
	
    return string_aux;
}

$("#submit-academic").click(function(){
	$(".modal-body").empty();
	$(".modal-footer").empty();
	
	if($("#select-matter").val() === 's'){
		var modal = $("#modal-information");
		
		modal.find('.modal-title').text("Cadastrar Acadêmico");
		modal.find('.modal-body').append("<p>Você não selecionou a MATÉRIA.</p>");
		
		modal.find('.modal-footer').append("<button class='btn btn-default btn-close' data-dismiss='modal'><i class='fa fa-close'></i> Fechar</button>");
		
		modal.modal("show");
		
		$("#select-matter").focus();
	}else if(arrayAcademic.length != 0){
		console.log(arrayAcademic);
		$.ajax({
			type: "post",
			dataType: "json",
			url: "class/controller/academic.php",
			data: {type: 3, matter: $("#select-matter").val(), academics: arrayAcademic},
			success: function(data){
				console.log(data);
				if(data.success){
					var modal = $("#modal-information");
					
					modal.find('.modal-title').text("Cadastrar Acadêmico");
					modal.find('.modal-body').append("<p>Os acadêmicos foram inserido com sucesso.</p>");
					
					modal.find('.modal-footer').append("<button class='btn btn-default btn-close' data-dismiss='modal'><i class='fa fa-close'></i> Fechar</button>");
					
					modal.modal("show");
				}else{
					alert("Erro: " + JSON.stringify(data, null, 4));
				}
			},
			error: function(data){
				alert("Erro: " + JSON.stringify(data, null, 4));
			}
		});
	}else{
		var modal = $("#modal-information");
		
		modal.find('.modal-title').text("Cadastrar Acadêmico");
		modal.find('.modal-body').append("<p>Você não selecionou nenhum ACADÊMICO.</p>");
		
		modal.find('.modal-footer').append("<button class='btn btn-default btn-close' data-dismiss='modal'><i class='fa fa-close'></i> Fechar</button>");
		
		modal.modal("show");
		
		$("#new-academic").focus();
	}
});